unit XferAdd;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
     StdCtrls, ExtCtrls, SysUtils,
     NWCalls, XFerUnit, Delphi_U;

type
  TAddObjectDialog = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    Bevel1: TBevel;
    ListBoxAddObj: TListBox;

    procedure ListBoxCreate(Sender: TObject; connID: NWCONN_HANDLE; OPattern: PChar; OType: NWOBJ_TYPE);
    procedure SelectObject(Sender: TObject; OPattern: PChar; OType: NWOBJ_TYPE);
    procedure CancelBtnClick(Sender: TObject);
    procedure GetSelectedObject(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKBtnClick(Sender: TObject);
    procedure ListBoxAddObjDblClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AddObjectDialog: TAddObjectDialog;
  selObjPattern:   PChar;
  selObjType:      NWOBJ_TYPE;
  chosenObj:       String;

implementation

{$R *.DFM}

procedure TAddObjectDialog.ListBoxCreate(Sender: TObject; connID: NWCONN_HANDLE; OPattern: PChar; OType: NWOBJ_TYPE);
begin
{   AddObjectDialog.Show; }
   ListBoxAddObjects(Sender, connID, ListBoxAddObj, OPattern, OType);
   AddObjectDialog.ShowModal;
end;

procedure TAddObjectDialog.SelectObject(Sender: TObject; OPattern: PChar; OType: NWOBJ_TYPE);
begin
  selObjPattern    := OPattern;
  selObjType       := OType;
end;

procedure TAddObjectDialog.CancelBtnClick(Sender: TObject);
begin
   ListBoxAddObj.ItemIndex := -1;
   AddObjectDialog.Close;
end;

procedure TAddObjectDialog.GetSelectedObject(Sender: TObject);
begin
   IF ListBoxAddObj.ItemIndex >= 0
      THEN chosenObj := ListBoxAddObj.Items[ListBoxAddObj.ItemIndex]
      else chosenObj := '';
   AddTermination(chosenObj);
end;

procedure TAddObjectDialog.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   GetSelectedObject(Sender);
end;

procedure TAddObjectDialog.OKBtnClick(Sender: TObject);
begin
{   GetSelectedObject(Sender); }
   AddObjectDialog.Close;
end;

procedure TAddObjectDialog.ListBoxAddObjDblClick(Sender: TObject);
begin
   AddObjectDialog.Close;
end;

procedure TAddObjectDialog.HelpBtnClick(Sender: TObject);
begin
   NotYet(Sender);
end;

end.
