unit XferUnit;
{  general variables/functions/procedures for XFER }

interface

uses
    NWCalls, Delphi_U,
    Forms, Controls, StdCtrls, Dialogs, SysUtils;

type

  TBinderyObject = RECORD
    ObjectName:          NWObjectName;
    ObjectID:            NWOBJ_ID;
    ObjectType:          NWOBJ_TYPE;
    END;

VAR
    cCode            : NWCCODE;
    searchObjType    : WORD;
    CFGsearchPattern : Str48;
    CFGDefPWD        : Str48;
    numConnections   : NWNumber;
    lastSrv          : BYTE;
    ObjectChanged    : Boolean;
    SelectedListBox  : TListBox;
    CurrentObject    : scanObjectRep;
    CurrentProperty  : scanPropRep;
    PV               : readPropValueRep;

    connID:         Array [0..1] of NWCONN_HANDLE;
    NWVers:         Array [0..1] of Real;
    curObj:         Array [0..1] of Integer;
    srvInfo:        Array [0..1] of CONNECT_INFO;
    UsrInfo:        Array [0..1] of TBinderyObject;

CONST
    CFGErrorThreshold : Byte = Err;

procedure GetObjectInfo(Sender: TObject; sType: NWOBJ_TYPE; sName: PChar; connID: NWCONN_HANDLE; Var O: scanObjectRep);
procedure GetCurrentObject(Sender: TObject; VAR SelectedListbox: TListBox; VAR O: scanObjectRep);
procedure ListBoxAddObjects(Sender: TObject; connID: NWCONN_HANDLE; VAR TargetList: TListBox;
                            OPattern: PChar; OType: NWOBJ_TYPE);
procedure AddSetToList(Sender: TObject; VAR TargetList: TListBox; OName: PChar; OType: NWOBJ_TYPE; propName: PChar);


implementation

procedure GetObjectInfo(Sender: TObject; sType: NWOBJ_TYPE; sName: PChar; connID: NWCONN_HANDLE; Var O: scanObjectRep);
begin
   with O Do {Begin }
   cCode := NWScanObject(connID, sName, sType, ObjectID,
                    ObjectName, ObjectType, ObjectHasProperties, ObjectFlag, ObjectSecurity);
   {end;}
end;


procedure GetCurrentObject(Sender: TObject; VAR SelectedListbox: TListBox; VAR O: scanObjectRep);
VAR   Name:              String;
begin
     FillChar(O, SizeOf(O), #0);
     cCode := $FFFF;
     IF SelectedListbox.Items.Count>0 THEN BEGIN
        O.ObjectID := -1;
        Name     := SelectedListbox.Items[curObj[lastSrv]];
        AddTermination(Name);
        GetObjectInfo(Sender, searchObjType, @Name[1], connID[lastSrv], O);
        end
end;

procedure ListBoxAddObjects(Sender: TObject; connID: NWCONN_HANDLE;
                       VAR TargetList: TListBox; OPattern: PChar; OType: NWOBJ_TYPE);
VAR   NewPos:            Integer;
      UserName:          String;
      Obj:               scanObjectRep;
      cCode:             NWCCODE;
begin
     Screen.Cursor := crHourGlass;
     Obj.objectID := -1;
     Repeat
     cCode := NWScanObject(connID, OPattern, OType, Obj.objectID, Obj.ObjectName,
              Obj.ObjectType, Obj.ObjecthasProperties, Obj.ObjectFlag, Obj.ObjectSecurity);
     IF cCode = 0 THEN BEGIN
        UserName := StrPas(@Obj.ObjectName);
        NewPos := TargetList.Items.IndexOf(UserName);
        IF (NewPos=-1) THEN NewPos := TargetList.Items.Add(UserName);
        IF (NewPos=-1) THEN TargetList.ItemIndex := NewPos;
        END;
     Until cCode > 0;
     Screen.Cursor := crDefault;
end;


procedure AddSetToList(Sender: TObject; VAR TargetList: TListBox;
                                    OName: PChar; OType: NWOBJ_TYPE; propName: PChar);
VAR
  cCodeV:            NWCCODE;
  i:                 byte;
  SetArray:          Array[0..31] of NWOBJ_ID;
  Mmb:               TBinderyObject;
  Screen:            TScreen;
begin
    ClearList(TargetList);
    PV.dataSetIndex := 1;
    repeat
       cCodeV := NWReadPropertyValue(connID[lastSrv], OName, OType,
                   propName, PV.dataSetIndex, PV.data, PV.moreFlag, PV.propertyFlags);
       if ((cCodeV<>$89EC) and (cCodeV<>$89FB))
          THEN ShowError(cCodeV, 'NWReadProperty '+StrPas(propName), Err, CFGErrorThreshold);
       if cCodeV=0 then begin { Read set }
          Move(PV.data, SetArray, SizeOf(SetArray));
          for i := 0 to 31 do
              if SetArray[i]<>0 THEN begin { Read set members }
                 cCode := NWGetObjectName(connID[lastSrv], SetArray[i], Mmb.ObjectName, Mmb.ObjectType);
                 ShowError(cCode, 'NWGetMmbName '+hex8(SetArray[i]), Err, CFGErrorThreshold);
                 if cCode=0 then TargetList.Items.Add(Mmb.ObjectName);
                 end;
          end;
       inc(PV.dataSetIndex);
       until cCodeV<>0;
end;




end.

