unit Xfer_u;

interface

uses
    NWCalls,
    Forms, Controls, StdCtrls, Dialogs, SysUtils;

type

  TBinderyObject = RECORD
    ObjectName:          NWObjectName;
    ObjectID:            NWOBJ_ID;
    ObjectType:          NWOBJ_TYPE;
    END;

VAR
    cCode            : NWCCODE;
    searchObjType    : WORD;
    CFGsearchPattern : Str48;
    CFGDefPWD        : Str48;
{    CFGErrorThreshold: BYTE; }
    numConnections   : NWNumber;
    lastSrv          : BYTE;
    ObjectChanged    : Boolean;
    SelectedListBox  : TListBox;
    CurrentObject    : scanObjectRep;
    CurrentProperty  : scanPropRep;
    PV               : readPropValueRep;

    connID:         Array [0..1] of NWCONN_HANDLE;
    NWVers:         Array [0..1] of Real;
    curObj:         Array [0..1] of Integer;
    srvInfo:        Array [0..1] of CONNECT_INFO;
    UsrInfo:        Array [0..1] of TBinderyObject;

CONST
    CFGErrorThreshold : Byte = Err;
{   CFGMainTop        : Integer = 150;
    CFGMainLeft       : Integer = 150; }

Procedure NotYet(Sender: TObject);
procedure SelectDefaultListItem(Sender: TObject; VAR SelectedListbox: TListBox; VAR pos: Integer);
procedure GetObjectInfo(Sender: TObject; sType: NWOBJ_TYPE; sName: PChar; connID: NWCONN_HANDLE; Var O: scanObjectRep);
procedure ChangeCurrentListboxEntry(VAR NewName: String; VAR SelectedListbox: TListBox);
procedure GetCurrentObject(Sender: TObject; VAR SelectedListbox: TListBox; VAR O: scanObjectRep);
procedure ClearList(VAR SelectedListbox: TListBox);
procedure AddListEntry(Sender: TObject; VAR SelectedListbox: TListBox; VAR NewEntry: String);
procedure DeleteListEntry(Sender: TObject; VAR SelectedListbox: TListBox; VAR Pos: Integer);
procedure ListBoxAddObjects(Sender: TObject; connID: NWCONN_HANDLE; VAR TargetList: TListBox;
                            OPattern: PChar; OType: NWOBJ_TYPE);
procedure AddSetToList(Sender: TObject; VAR TargetList: TListBox; OName: PChar; OType: NWOBJ_TYPE; propName: PChar);


implementation

Procedure NotYet(Sender: TObject);
begin
   ShowMessage('This Function is not Implemented in this Version');
end;

procedure SelectDefaultListItem(Sender: TObject; VAR SelectedListbox: TListBox; VAR pos: Integer);
begin
   if (SelectedListbox.ItemIndex >= 0)                      { override pos if valid position }
      then pos := SelectedListbox.ItemIndex          else
   if ((Pos <= -1) and (SelectedListbox.Items.Count > 0))   { if none selected, select first }
      then Pos := 0                                  else
   if ( Pos >= SelectedListbox.Items.Count)                 { too big }
      then Pos := Pred(SelectedListbox.Items.Count);
   SelectedListbox.ItemIndex := pos;
(*
   if ((SelectedListbox.ItemIndex=-1) and (SelectedListbox.Items.Count>0))
      then SelectedListbox.ItemIndex := 0;  { if none selected then select first item }
   pos := SelectedListbox.ItemIndex;
*)
end;

procedure GetObjectInfo(Sender: TObject; sType: NWOBJ_TYPE; sName: PChar; connID: NWCONN_HANDLE; Var O: scanObjectRep);
begin
   with O Do Begin
   cCode := NWScanObject(connID, sName, sType, ObjectID,
                    ObjectName, ObjectType, ObjectHasProperties, ObjectFlag, ObjectSecurity);
   end;
end;

procedure ChangeCurrentListboxEntry(VAR NewName: String; VAR SelectedListbox: TListBox);
{ NewName must be #0 terminated }
VAR Pos, NewPos:       Integer;
begin
   Pos    := SelectedListbox.ItemIndex;
   SelectedListbox.Items.Delete(Pos);
   NewPos := SelectedListbox.Items.Add(NewName);
   SelectedListbox.ItemIndex := NewPos;
end;


procedure GetCurrentObject(Sender: TObject; VAR SelectedListbox: TListBox; VAR O: scanObjectRep);
VAR   Name:              String;
begin
     FillChar(O, SizeOf(O), #0);
     cCode := $FFFF;
     IF SelectedListbox.Items.Count>0 THEN BEGIN
        O.ObjectID := -1;
        Name     := SelectedListbox.Items[curObj[lastSrv]];
        AddTermination(Name);
        GetObjectInfo(Sender, searchObjType, @Name[1], connID[lastSrv], O);
        end
end;



procedure ClearList(VAR SelectedListbox: TListBox);
begin
     While SelectedListbox.Items.Count > 0
           DO SelectedListbox.Items.Delete(0);
end;

procedure AddListEntry(Sender: TObject; VAR SelectedListbox: TListBox; VAR NewEntry: String);
VAR NewPos : Integer;
begin
   NewPos := SelectedListbox.Items.IndexOf(NewEntry);
   IF (NewPos=-1) THEN begin
      NewPos := SelectedListbox.Items.Add(NewEntry);
      SelectedListbox.ItemIndex := NewPos;
      end;
end;


procedure DeleteListEntry(Sender: TObject; VAR SelectedListbox: TListBox; VAR Pos: Integer);
begin
   SelectedListbox.Items.Delete(Pos);
   IF Pos <> SelectedListbox.ItemIndex THEN BEGIN {change current index}
         IF Pos>=SelectedListbox.Items.Count THEN Pos := Pred(SelectedListbox.Items.Count);
      END;
   SelectedListBox.ItemIndex := Pos;
end;


procedure ListBoxAddObjects(Sender: TObject; connID: NWCONN_HANDLE;
                       VAR TargetList: TListBox; OPattern: PChar; OType: NWOBJ_TYPE);
VAR   NewPos:            Integer;
      UserName:          String;
      Obj:               scanObjectRep;
      cCode:             NWCCODE;
begin
     Screen.Cursor := crHourGlass;
     Obj.objectID := -1;
     Repeat
     cCode := NWScanObject(connID, OPattern, OType, Obj.objectID, Obj.ObjectName,
              Obj.ObjectType, Obj.ObjecthasProperties, Obj.ObjectFlag, Obj.ObjectSecurity);
     IF cCode = 0 THEN BEGIN
        UserName := StrPas(@Obj.ObjectName);
        NewPos := TargetList.Items.IndexOf(UserName);
        IF (NewPos=-1) THEN NewPos := TargetList.Items.Add(UserName);
        IF (NewPos=-1) THEN TargetList.ItemIndex := NewPos;
        END;
     Until cCode > 0;
     Screen.Cursor := crDefault;
end;


procedure AddSetToList(Sender: TObject; VAR TargetList: TListBox;
                                    OName: PChar; OType: NWOBJ_TYPE; propName: PChar);
VAR
  cCodeV:            NWCCODE;
  i:                 byte;
  SetArray:          Array[0..31] of NWOBJ_ID;
  Mmb:               TBinderyObject;
  Screen:            TScreen;
begin
    ClearList(TargetList);
    PV.dataSetIndex := 1;
    repeat
       cCodeV := NWReadPropertyValue(connID[lastSrv], OName, OType,
                   propName, PV.dataSetIndex, PV.data, PV.moreFlag, PV.propertyFlags);
       if ((cCodeV<>$89EC) and (cCodeV<>$89FB))
          THEN ShowError(cCodeV, 'NWReadProperty '+StrPas(propName), Err, CFGErrorThreshold);
       if cCodeV=0 then begin { Read set }
          Move(PV.data, SetArray, SizeOf(SetArray));
          for i := 0 to 31 do
              if SetArray[i]<>0 THEN begin { Read set members }
                 cCode := NWGetObjectName(connID[lastSrv], SetArray[i], Mmb.ObjectName, Mmb.ObjectType);
                 ShowError(cCode, 'NWGetMmbName '+hex8(SetArray[i]), Err, CFGErrorThreshold);
                 if cCode=0 then TargetList.Items.Add(Mmb.ObjectName);
                 end;
          end;
       inc(PV.dataSetIndex);
       until cCodeV<>0;
end;




end.

